function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
var _excluded = ["index", "__is_group", "children", "__is_drag_sort"],
  _excluded2 = ["title", "editable", "children", "dataIndex", "field_type", "record", "handleSave", "lock", "render"];
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(arr, i) { var _i = null == arr ? null : "undefined" != typeof Symbol && arr[Symbol.iterator] || arr["@@iterator"]; if (null != _i) { var _s, _e, _x, _r, _arr = [], _n = !0, _d = !1; try { if (_x = (_i = _i.call(arr)).next, 0 === i) { if (Object(_i) !== _i) return; _n = !1; } else for (; !(_n = (_s = _x.call(_i)).done) && (_arr.push(_s.value), _arr.length !== i); _n = !0); } catch (err) { _d = !0, _e = err; } finally { try { if (!_n && null != _i.return && (_r = _i.return(), Object(_r) !== _r)) return; } finally { if (_d) throw _e; } } return _arr; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
import { Form, Tooltip } from 'antd';
import { useSortable } from '@dnd-kit/sortable';
import { CSS } from '@dnd-kit/utilities';
import { MenuOutlined } from '@ant-design/icons';
import classNames from 'classnames';
import React, { useMemo } from 'react';
import CellProvider from "./CellProvider";
import { getText } from "../../../../../locales";
import "./index.less";
export var EditableContext = /*#__PURE__*/React.createContext(null);
var EditableRow = function EditableRow(_ref) {
  var index = _ref.index,
    __is_group = _ref.__is_group,
    children = _ref.children,
    __is_drag_sort = _ref.__is_drag_sort,
    props = _objectWithoutProperties(_ref, _excluded);
  var _Form$useForm = Form.useForm(),
    _Form$useForm2 = _slicedToArray(_Form$useForm, 1),
    form = _Form$useForm2[0];
  var parentForm = Form.useFormInstance();
  var order_by = Form.useWatch('order_by', parentForm);
  var _useSortable = useSortable({
      id: props['data-row-key']
    }),
    attributes = _useSortable.attributes,
    listeners = _useSortable.listeners,
    setNodeRef = _useSortable.setNodeRef,
    setActivatorNodeRef = _useSortable.setActivatorNodeRef,
    transform = _useSortable.transform,
    transition = _useSortable.transition,
    isDragging = _useSortable.isDragging;
  var style = _objectSpread(_objectSpread({}, props.style), {}, {
    transform: CSS.Transform.toString(transform && _objectSpread(_objectSpread({}, transform), {}, {
      scaleY: 1
    })),
    transition: transition
  }, isDragging && __is_drag_sort ? {
    position: 'relative',
    zIndex: 9999
  } : {});
  var cells = useMemo(function () {
    if (__is_group) {
      return children;
    }
    return React.Children.map(children, function (child) {
      if (child.key === '__sort') {
        var handleIcon = order_by ? /*#__PURE__*/React.createElement(Tooltip, {
          title: getText('table-column-drag-sort-disabled-tip')
        }, /*#__PURE__*/React.createElement(MenuOutlined, {
          className: "pisell-lowcode-menu-out-lined-icon"
        })) : /*#__PURE__*/React.createElement(MenuOutlined, _extends({
          ref: setActivatorNodeRef,
          className: "pisell-lowcode-menu-out-lined-icon"
        }, listeners));
        return /*#__PURE__*/React.cloneElement(child, {
          children: handleIcon
        });
      }
      return child;
    });
  }, [__is_group, children, order_by, setActivatorNodeRef, listeners]);
  return /*#__PURE__*/React.createElement(Form, {
    form: form,
    component: false
  }, /*#__PURE__*/React.createElement(EditableContext.Provider, {
    value: form
  }, __is_group && /*#__PURE__*/React.createElement("tr", {
    style: {
      height: 12
    }
  }), /*#__PURE__*/React.createElement("tr", _extends({}, props, {
    ref: setNodeRef,
    style: style
  }, attributes), cells)));
};
var EditableCell = function EditableCell(props) {
  var title = props.title,
    editable = props.editable,
    children = props.children,
    dataIndex = props.dataIndex,
    field_type = props.field_type,
    record = props.record,
    handleSave = props.handleSave,
    lock = props.lock,
    render = props.render,
    restProps = _objectWithoutProperties(props, _excluded2);
  return /*#__PURE__*/React.createElement("td", _extends({}, restProps, {
    className: classNames(restProps.className, 'ant-table-cell', 'materials-grid-table-cell')
  }), /*#__PURE__*/React.createElement(CellProvider, props));
};
export default {
  Row: EditableRow,
  Coll: EditableCell
};